dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger( colliding_entity )
	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)
	local parent_id = EntityGetParent( entity_id )

	local comp_id = EntityGetFirstComponent( colliding_entity, "SimplePhysicsComponent")
	local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))
	
	if parent_id > 0 and comp_id then
	
		for i, child_id in ipairs(EntityGetAllChildren(colliding_entity) or {}) do
			
			local item_comp_id = EntityGetFirstComponentIncludingDisabled( child_id, "ItemActionComponent")
			
			if (ComponentGetValue2( item_comp_id, "action_id" ) == "RAINBOW_TRAIL") and tablets_found >= 5 then
				
				rainbow_trail_found = true
				
			elseif ComponentGetValue2( item_comp_id, "action_id" ) == "MIST_BLOOD"
			or ComponentGetValue2( item_comp_id, "action_id" ) == "MATERIAL_BLOOD"
			or ComponentGetValue2( item_comp_id, "action_id" ) == "TOUCH_BLOOD"
			or ComponentGetValue2( item_comp_id, "action_id" ) == "BLOOD_MAGIC"
			or ComponentGetValue2( item_comp_id, "action_id" ) == "BLOOD_TO_POWER"
			or ComponentGetValue2( item_comp_id, "action_id" ) == "BLOODLUST"
			or ComponentGetValue2( item_comp_id, "action_id" ) == "CLOUD_BLOOD" then
			
				blood_trail_found = true
				
			end

		end
		if rainbow_trail_found or blood_trail_found then
			local parent_x, parent_y = EntityGetTransform(parent_id)
			
			local sprite_comp = EntityGetFirstComponentIncludingDisabled( parent_id, "SpriteComponent")
			
			EntityAddComponent2(parent_id, "LuaComponent", {
				execute_every_n_frame=1,
				script_source_file="mods/cloudmillion_quest/files/armageddon_machine/screen_shake.lua" 
			})
			
			-- EntityAddComponent2(parent_id, "AudioLoopComponent", {
				-- file="data/audio/Desktop/fx.bank",
				-- event_name="fx/fx_concentration",
				-- calculate_material_lowpass=false,
				-- auto_play=true,
			-- })
			
			GamePlaySound( "data/audio/Desktop/misc.snd", "misc/chest_dark_open", x, y )
			GamePlaySound( "data/audio/Desktop/event_cues.bank", "event_cues/happy_ending/create", x, y )
			
			if rainbow_trail_found then
				ComponentSetValue2(sprite_comp, "rect_animation", "active_rainbow")
				ComponentSetValue2(sprite_comp, "next_rect_animation", "active_rainbow")
				
				EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol_rainbow.xml", x, y-12 )
				
				EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol_rainbow.xml", x - 100, y + 100 )
				
				EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol_rainbow.xml", x + 100, y + 100 )
				
				EntityAddComponent2(parent_id, "LuaComponent", {
					execute_every_n_frame=10,
					script_source_file="mods/cloudmillion_quest/files/armageddon_machine/win.lua" 
				})
			elseif blood_trail_found then
				ComponentSetValue2(sprite_comp, "rect_animation", "active_blood")
				ComponentSetValue2(sprite_comp, "next_rect_animation", "active_blood")
				
				EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol.xml", x, y-12 )
				
				EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol.xml", x - 100, y + 100 )
				
				EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/magical_symbol.xml", x + 100, y + 100 )
				
				local world_state_entity = GameGetWorldStateEntity()
				EntityAddComponent2(world_state_entity, "LuaComponent", {
					execute_every_n_frame=10,
					script_source_file="mods/cloudmillion_quest/files/armageddon_machine/destruction.lua" 
				})
			end
			
			-- local audio_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "AudioLoopComponent")
			
			-- EntitySetComponentsWithTagEnabled( entity_id, enabled_in_world, true )
			
			EntityKill(colliding_entity)
			
			EntityKill(entity_id)
		end
		
	end
end