dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local number = GetValueNumber("number", 0)
SetValueNumber("number", number + 1)

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

if number >= 10 then

	for i=1,Random(1,10) do
		local x = x + Random (72, 170)
		local y = y + Random (39, 240)
		GamePlaySound( "data/audio/Desktop/misc.snd", "misc/chest_dark_open", x, y )
		EntityLoad("data/entities/particles/particle_explosion/main_small.xml", x, y )
	end
	
end
	
if number >= 20 then
	-- for i=1,17 do
		-- local chunk_id = EntityCreateNew()
		-- EntitySetTransform(chunk_id, x, y)
		
		-- EntityAddComponent2(chunk_id, "PhysicsBodyComponent", {
			-- kills_entity=true,
			-- on_death_leave_physics_body=true
		-- } )
		
		-- EntityAddComponent2(chunk_id, "PhysicsImageShapeComponent", {
		  -- centered=true,
		  -- image_file="mods/cloudmillion_quest/files/armageddon_machine/physics_chunks/chunk" .. i .. ".png",
		  -- material=CellFactory_GetType( "steel" ) 
		-- } )

	-- end
	
	function create_ragdoll(path)
	
		local ragdoll_id = EntityCreateNew()
		EntitySetTransform(ragdoll_id, x, y)
		
		EntityAddComponent(ragdoll_id, "DamageModelComponent", {
            hp="1",
            ragdoll_material="steel",
			ragdoll_filenames_file = path ,
			blood_material="oil",
			blood_spray_material="oil",
			ragdoll_offset_y = 145,
			ragdoll_offset_x = 122
		} )
		
		local ragdoll_damage_model_component = EntityGetFirstComponentIncludingDisabled(ragdoll_id, "DamageModelComponent")
		
		ComponentSetValue2(ragdoll_damage_model_component, "hp", 0)
		ComponentSetValue2(ragdoll_damage_model_component, "air_needed", true)
		ComponentSetValue2(ragdoll_damage_model_component, "air_in_lungs", 0)
	
	end
	
	create_ragdoll("mods/cloudmillion_quest/files/armageddon_machine/physics_chunks/chunks.txt")
	EntityLoad("mods/cloudmillion_quest/files/armageddon_machine/explosion_death_particle.xml", x + 145, y + 122 )
	
	local world_state_entity = GameGetWorldStateEntity()
	EntityAddComponent2(world_state_entity, "LuaComponent", {
		execute_every_n_frame=1,
		script_source_file="mods/cloudmillion_quest/files/armageddon_machine/time_restore.lua" 
	})
	edit_component( world_state_entity, "WorldStateComponent", function(comp,vars)
		vars.time_dt = 1
	end)
	
	GamePlaySound( "data/audio/Desktop/misc.snd", "misc/sun/supernova", x + 145, y + 122 )
	GamePlaySound( "data/audio/Desktop/explosion.snd", "explosions/nuke", x + 145, y + 122 )
	
	GlobalsSetValue("cloudmillion_quest_ending_triggered", "1")
	AddFlagPersistent( "armageddon_machine" )
	
	EntityKill(entity_id)
end