dofile_once( "data/scripts/lib/utilities.lua" )

function rotate_degrees(x, y, degrees)
	return rotate_radians(x, y, math.rad(degrees))
end

function rotate_radians(x, y, radians)
	local ca = math.cos(radians)
	local sa = math.sin(radians)
	local out_x = ca * x - sa * y
	local out_y = sa * x + ca * y
	return out_x, out_y
end

function shoot_at_entity(self_entity, target_entity, general_offset, x_offset, y_offset, speed, projectile, maxdistance, max_player_distance, rotation_offset)
	local rad_offset = 0
	if(rotation_offset ~= nil)then
		rad_offset = rotation_offset
	end
	local x, y = EntityGetTransform(self_entity)
	
	if(target_entity ~= nil)then
		local entityX, entityY = EntityGetTransform( target_entity )

		local headingX = entityX - (x + x_offset)
		local headingY = (entityY-5) - (y + y_offset)
		
		local len = math.sqrt((headingX*headingX) + (headingY*headingY))

		local directionX = headingX / len
		local directionY = headingY / len

		local didHit, hitX, hitY = RaytraceSurfaces( x, y, entityX, entityY )

		local headingHitX = entityX - hitX
		local headingHitY = entityY - hitY

		local hitDistance = math.sqrt((headingHitX*headingHitX) + (headingHitY*headingHitY))

		local pos_x, pos_y, currentRotation = EntityGetTransform( self_entity )	

		if(directionX < 0)then
			EntitySetTransform(self_entity,pos_x,pos_y,currentRotation,-1,1)
		else
			EntitySetTransform(self_entity,pos_x,pos_y,currentRotation,1,1)
		end
	
		if(len < max_player_distance)then
			if(hitDistance < maxdistance)then
			
				directionX, directionY = rotate_degrees(directionX, directionY, rad_offset)
				
				
				local ourProjectile = shoot_projectile( self_entity, projectile, x + (directionX * general_offset) + x_offset, y + (directionY * general_offset) + y_offset, directionX * speed, directionY * speed, false )
				edit_component( ourProjectile, "ProjectileComponent", function(comp,vars)
					vars.mWhoShot       = self_entity
					vars.mShooterHerdId = "player"
				end)
			end
		end
	end
end

local entity_id = GetUpdatedEntityID()

local players = EntityGetWithTag("player_unit")

local x, y = EntityGetTransform( entity_id )

local closestEntity = get_players()[1]

-- function play_animation( entity_id, animation_name, next_animation )
    -- local sprite_components = EntityGetComponent( entity_id, "SpriteComponent" )
    -- if( sprite_components ~= nil ) then
        -- for i,v in ipairs(sprite_components) do
            -- ComponentSetValue2( v, "rect_animation", animation_name)
            -- ComponentSetValue2( v, "next_rect_animation", next_animation)
        -- end
    -- end
-- end

if(closestEntity ~= nil)then
	if BiomeMapGetName() ~= "$biome_holymountain" and #players > 0 then
	
		shoot_at_entity(entity_id, closestEntity, 1, 0, 4, 51, "mods/cloudmillion_quest/files/projectiles/phasing_shot.xml", 900, 200)
	
		-- play_animation(entity_id, "attack", "stand")
	end
end