dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/perks/perk.lua")

function collision_trigger( colliding_entity_id )
	local entity_id    = GetUpdatedEntityID()
	local pos_x, pos_y = EntityGetTransform( entity_id )
	local tablet_x, tablet_y = EntityGetTransform( colliding_entity_id )
	local item_component = EntityGetFirstComponentIncludingDisabled( colliding_entity_id, "ItemComponent" )
	local tablet_desc = ComponentGetValue2( item_component, "ui_description" )
	if tablet_desc == "$alchemist_note_desc1_confused" then
	
		-- if (GlobalsGetValue("cloudmillion_quest_tablet1_found") == "1") then 
			-- return
		-- end
		
		--Changing description to readable
		ComponentSetValue2( item_component, "ui_description", "$alchemist_note_desc1" )
		
		--Particles
		EntityLoad("data/entities/particles/gold_pickup_huge.xml", tablet_x, tablet_y )
		
		--Audio
		GameTriggerMusicFadeOutAndDequeueAll( 3.0 )
		GameTriggerMusicEvent( "music/oneshot/dark_01", true, pos_x, pos_y )
		
		--Ruby Tablet Perk
		if (GlobalsGetValue("cloudmillion_quest_radar_found") == "1") then 
			return
		end
		
		perk_spawn( pos_x, pos_y - 23, "RUBY_TABLET_RADAR" )
		
		GlobalsSetValue("cloudmillion_quest_radar_found", "1")
		
		--Adding world conversion activation to the tablet if it's picked up
		-- GlobalsSetValue("cloudmillion_quest_tablet1_found", "1")

		-- local tablets_found = tonumber(GlobalsGetValue("cloudmillion_quest_tablets_found", "0"))

		-- --Here im setting the amount of tablets found to the current amount + 1 cause we just picked up ruby tablet 1
		-- GlobalsSetValue("cloudmillion_quest_tablets_found", tablets_found + 1)
	end
	
end